package Flier_Match.FMCliente.sistema;

import java.awt.Frame;
import java.awt.event.KeyEvent;
import java.util.Date;

import Flier_Match.FMCliente.motion.Bullet;
import Flier_Match.FMCliente.motion.BulletThread;
import Flier_Match.FMCliente.red.TCPManejo;
import Flier_Match.FMCliente.sonido.ManejadorSonidos;
import Flier_Match.FMCliente.video.RenderThread;
import Flier_Match.FMRed.ListaRed;
import Flier_Match.FMRed.NodoRed;
import Flier_Match.FMRed.PetNave;
import Flier_Match.FMRed.Peticion;
import Flier_Match.FMRed.Respuesta;

import com.threed.jpct.Camera;
import com.threed.jpct.Matrix;
import com.threed.jpct.Object3D;
import com.threed.jpct.SimpleVector;
import com.threed.jpct.TextureManager;
import com.threed.jpct.World;
import com.threed.jpct.util.KeyMapper;
import com.threed.jpct.util.KeyState;

public class ManejadorEventos extends Thread{

	public int id;//es el id de la nave dentro de la lista de jugadores
	public World Actual;
	public Camera actualCam;
	public Object3D naveActual;
	public World Juego;
	public World Splash;
	public World Menu;
	public World Naves;
	public World Trailer;

    public String mensajeSalida="";
    public String naveNombre="";//es el nombre de la nave del jugador, el nombre con el que se identifica dentro del juego
    public String mensajeEntrada="";
    public int vida;
    
	private KeyState estadoTeclas;
	private KeyMapper mapaTeclas;
	
	private Lista navesLista;
	public ListaRed jugadores;
	public NodoRed nodoPropio;
	public int idOpcion=3;//identifica la opcion que seala el menu
	public int idNave=1;//identifica el tipo de nave a utilizar
	
	private boolean adelante;
	private boolean atras;
	private boolean giroIzq;
	private boolean giroDer;
	private boolean giroArr;
	private boolean giroAba;
	private boolean strafeIzq;
	private boolean strafeDer;
	private boolean strafeArr;
	private boolean strafeAba;
	private boolean disparoBala;
	private boolean disparoMisil;
	private boolean chat;
    
	private boolean escape;
	private boolean arriba;
	private boolean abajo;
	private boolean izquierda;
	private boolean derecha;
	private boolean enter;
    
    public boolean salida=false;
    public boolean jugando=false;
    public boolean chateando=false;
    
    private TCPManejo conexion;

	private Parametros param;
	
	private Peticion P;
    private Respuesta R;
    
    private String host;
    private int puerto;
    
    public boolean salir;
    
    private RenderThread render;
    private BulletThread balas;
    
    private String mensajeChat;//es el mensaje que se esta escribiendo
    
	/**
     * Identificador sobre que World esta siendo presentado, usado para el
     * manejo de eventos.
     * 1=Menu, 2=Naves, 3=Trailers y 4=Juego
     */
	public int idWorld;//4=juego, 3=Naves, 2=Trailer, 1=salir

    private volatile long tiempo=0;
	
    private ManejadorSonidos player;
    
    private float animIndex1=0;
    private float animIndex2=0;
    private float animIndex3=0;
    private float animIndex4=0;
    private float animIndex5=0;
    
    private boolean animSplash;
    
    private TextureManager TM;
    
    private boolean checkNuevo;
    private boolean checkSalida;
    
    private Object datoNuevo;
    private Object datoSalida;
    
	public ManejadorEventos (Object dato, int id, ManejadorSonidos player) {
		initME (dato, id, player);
	}
	
	public ManejadorEventos (TextureManager aTM) {
		salir=false;
		TM=aTM;
	}
	
	public void initME (Object dato, int id, ManejadorSonidos player) {
		this.player=player;
		if (id==1) {
			Frame GUI=(Frame) dato;
			mapaTeclas=new KeyMapper (GUI);
		}
		if (id==2) {
			mapaTeclas=new KeyMapper ();
		}
		animSplash=true;
		salir=false;
		
		checkNuevo=false;
	    checkSalida=false;
	    
	}
	
	public void setNavesLista (Lista info) {
		navesLista=info;
	}
	public void setParametros (Parametros info) {
		param=info;
	}
	public void setConexion (TCPManejo info) {
		conexion=info;
	}
	public void setTCP (String ahost, int apuerto) {
		host=ahost;
		puerto=apuerto;
	}
	public void setWorlds (World aSplash, World aMenu, World aNaves, World aTrailer) {
		Menu=aMenu;
		Naves=aNaves;
		Trailer=aTrailer;
		Splash=aSplash;
		Actual=Splash;
	}
	
	public void ejecutarComandos () {
		actualCam=Actual.getCamera ();
		
		if (chateando) {
			appendChatChar ();
			hacerMovimientos ();
		} else {
			estadoTeclas=null;
            
            do {
                estadoTeclas=mapaTeclas.poll();
                if (estadoTeclas!=KeyState.NONE) {
                    obtenerEventos (estadoTeclas);
                }
            } while (estadoTeclas!=KeyState.NONE);
            
            hacerMovimientos ();
		}
        
    }
	
	private void hacerMovimientos () {
        
		if (Actual==Splash) {
			eventosSplash ();
		} else {
			if (idWorld==1) {
				eventosMenu ();
			}
		    
		    if (idWorld==2) {//World de Trailer
		    	eventosTrailer ();
		    }
		        
		    if (idWorld==3) {//World de Naves
		    	eventosNaves ();         
		    }
		        
		    if (idWorld==4) {//Juego en si
		    	eventosJuego ();
		    }
		}
       
    }
	
	private void eventosSplash () {
		if (escape) {
			//salir del splash y liberar sus recursos
			Actual=Menu;
		}
		
		if (animSplash) {
			try {
				Object3D sp1=Actual.getObjectByName("SPJPCT");
	        	Object3D sp2=Actual.getObjectByName("SPJAVA");
	        	Object3D sp3=Actual.getObjectByName("SPOAL");
	        	Object3D sp4=Actual.getObjectByName("SPLWJGL");
	        	Object3D sp5=Actual.getObjectByName("SPOGL");
	        	
	        	if (animIndex5>(0.949-0.01f)){
	        		animSplash=false;
	        		animIndex5=0.949f;
	        	} else {
	        		animIndex5=animIndex5+0.015f;
	        	}
	        	if (animIndex4<=(0.949f-0.02f)){
	    			animIndex4=animIndex4+0.02f;
	        	} else animIndex4=0.949f;
	        	if (animIndex3<=(0.949f-0.03f)){
	    			animIndex3=animIndex3+0.03f;
	        	} else animIndex3=0.949f;
	        	if (animIndex2<=(0.949f-0.04f)){
	    			animIndex2=animIndex2+0.04f;
	        	} else animIndex2=0.949f;
	        	if (animIndex1<=(0.949f-0.05f)){
	    			animIndex1=animIndex1+0.05f;
	        	} else animIndex1=0.949f;
	        	
	        	sp1.animate(animIndex1);
	        	sp2.animate(animIndex2);
	        	sp3.animate(animIndex3);
	        	sp4.animate(animIndex4);
	        	sp5.animate(animIndex5);
	        	/*
	        	System.out.println ("Animando splash5 en: "+animIndex5);
	        	System.out.println ("Animando splash4 en: "+animIndex4);
	        	System.out.println ("Animando splash3 en: "+animIndex3);
	        	System.out.println ("Animando splash2 en: "+animIndex2);
	        	System.out.println ("Animando splash1 en: "+animIndex1);*/
			} catch (Exception E) {
				System.out.println ("Error moviendo los objectos del splash"+E.getMessage());
			}
        	
		}else {
			try {
				Thread.sleep(8000);
			} catch (Exception E) {}
			Actual=Menu;
		}
		
	}
	
	private void eventosNaves () {
        
        Object3D ntemp=naveActual;
        naveActual=navesLista.getObject3DByX (0, 80f);

        if (escape) {
            naveActual=ntemp;
            Actual=Menu;
            idWorld=1;
            escape=false;
        }
        
        if (arriba) {
            if (idNave<navesLista.getTamao ()) {
                navesLista.translate (-400, new SimpleVector (1, 0, 0));
                idNave++;
                arriba=false;
            }
        }
        if (abajo) {
            if (idNave>1) {
                navesLista.translate (400, new SimpleVector (1, 0, 0));
                idNave--;
                abajo=false;
            }
        }
        if (izquierda) {    
            naveActual.rotateY (0.04f);
        }
        if (derecha) {
            naveActual.rotateY (-0.04f);
        }
        if (enter) {
            Actual=Menu;
            idWorld=1;
            enter=false;
        }
    }

    private void eventosJuego () {

        Peticion P=null;
       
        if (escape) {
            //falta: salir
        	
        	P=new Peticion ("", null, 3);
        	
        	conexion.enviar (P);
            conexion.recibir ();
            R=null;
            try {
            	R=conexion.getRespuesta ();
                jugadores= (ListaRed) R.dato;
            } catch (Exception E) {
            	R=null;
            	System.out.println ("Error "+E.getMessage()+" al obtener la informacion de la respuesta ya recibida");
            }
             
             //Actual=Juego;
             
            manejarRespuesta (R.idRespuesta);
             
        	Actual=Menu;
            idWorld=1;
            escape=false;
            
        } else {
        	
        	 int numeroEventos=calcularNumeroEventos ();
        	 
        	 if (numeroEventos==-1) {//si se ha presionado la tecla del chat.
        		 chat=false;
        		 chateando=!chateando;
        		 mensajeChat="";
        	 }
        	 
        	 int eventos []=new int [1];
        	              
        	 if (chateando) {
        		 render.setEnChat(true);
        	 } else {
        		 numeroEventos=calcularNumeroEventos ();
        		 eventos=crearArregloEventos (numeroEventos);
        	 }
        	 
        	 P=new Peticion (mensajeSalida, eventos, 1);

             conexion.enviar (P);
             
             conexion.recibir ();
             mensajeSalida="";
             R=null;
             try {
            	 R=conexion.getRespuesta ();
            	 jugadores= (ListaRed) R.dato;
             } catch (Exception E) {
            	 R=null;
            	 System.out.println ("Error "+E.getMessage()+" al obtener la informacion de la respuesta ya recibida");
            	 //E.printStackTrace();
             }
             
             //Actual=Juego;
             
             manejarRespuesta (R.idRespuesta);

             if (disparoBala) {//TODO quitar este disparo de prueba y hacerlo bien
          		disparoBala=false;
          		balas.agregarDisparo(Actual.getCamera().getPosition(), Actual.getCamera().getDirection(), Bullet.BULLET_BALA1, Actual, Actual.getCamera());	
             }
             if (disparoMisil) {//TODO quitar este disparo de prueba y hacerlo bien
            	 disparoMisil=false;
            	 balas.agregarDisparo(Actual.getCamera().getPosition(), Actual.getCamera().getDirection(), Bullet.BULLET_MISIL1, Actual, Actual.getCamera());	
             }
             
             /* CODIGO PARA VER DESDE EL CIELO LA POSICION DE LA NAVE SIN AFECTAR SU MOVIMIENTO, ES IMPORTANTE QUE ESTE DESPUES DEL METODO MANEJARRESPUESTA
             SimpleVector pos=Actual.getCamera().getPosition();
        	 Actual.getCamera().moveCamera(new SimpleVector (0,-1,0), 20f);
        	 Actual.getCamera().lookAt(pos);*/
             
             jugadores.mover (id, Juego);//mueve a todas las naves excepto la del id pasado por parametro
             
             
        }
    }


    private void eventosMenu () {
    	
    	if (animSplash==false) {//si recien entra al Menu despues del Splash, libere todo lo relacionado al Splash
    		
    		animSplash=true;
    		Splash.removeAllLights();
    		Splash.removeAllObjects();
    		Splash=null;
    	}
    	
    	if (jugando) {
    		Juego.removeAll();
    		Juego=null;
    		jugando=false;
    	}
    	
        Object3D seleccionador=GameLoop.seleccionador;
        if (arriba) {
            if (idOpcion <4 && idOpcion >=1) {
                seleccionador.translate (new SimpleVector (0, -100, 0));
                idOpcion++;
            }
            arriba=false;
        }
        if (abajo) {
            if (idOpcion <=4 && idOpcion >1) {
                seleccionador.translate (new SimpleVector (0, +100, 0));
                idOpcion--;
            }
            abajo=false;
        }
        if (enter) {
            if (idOpcion==1) {// if the quit option is selected
                salir=true;
                System.exit(1);
            }
            if (idOpcion==2) {//
                Actual=Trailer;
                idWorld=2;
            }
            if (idOpcion==3) {//World to select the crafts (naves)
                Actual=Naves;
                idWorld=3;
            }
            if (idOpcion==4) {//when beggining to play
                
                if (naveActual==null) naveActual= (Object3D) navesLista.getFirstObject ();//if there is not a selected craft
                naveActual.translate ((new SimpleVector (0, 0, 0).calcSub (naveActual.getTranslation ())));//putting the craft on the center
                //TODO FALTA alinear la nave para iniciar el juego
                

                //Naves.removeAllLights();
                //Naves.removeAllObjects ();
                //Naves=null;
                
                conexion=new TCPManejo (host, puerto);
                
                P=new Peticion ("", null, 0);
                conexion.enviar (P);
                P=null;
                
                //TODO verificar este codigo
                naveActual.rotateY((float) Math.PI);
                naveActual.rotateMesh();
                naveActual.setRotationMatrix(new Matrix());
                
                PetNave P2=new PetNave (naveActual, param.getNickname (), param.getColor ());
                conexion.enviar (P2);
                Respuesta R;
                conexion.recibir ();
                R=conexion.getRespuesta ();
                Juego=(World) R.dato;
                Juego.buildAllObjects ();
                Juego.setAmbientLight (180, 180, 180);
                
                Object3D mapa=Juego.getObjectByName("Mapa");
                mapa.setCollisionMode(Object3D.COLLISION_CHECK_OTHERS | Object3D.COLLISION_CHECK_SELF);
                mapa.build();
                
                System.out.println ("Recibiendo identificador del jugador y su nave");
                conexion.recibir ();
                R=conexion.getRespuesta ();
                id=((Integer) R.dato).intValue();
                System.out.println ("Identificador recibido: "+id);
                
                actualCam=Juego.getCamera ();

                naveNombre="Nave"+id;
                Juego.removeObject (Juego.getObjectByName (naveNombre));//removing the own craft from the personalizaed world
                
                Actual=Juego;
                
                idWorld=4;
                jugando=true;
                
            }
            enter=false;
        }
        if (escape) {
            if (jugando) Actual=Juego;
            escape=false;
        }
    }
    
    private void eventosTrailer () {
        if (escape) {
            Actual=Menu;
            idWorld=1;
            escape=false;
        }
    }
    
    private void obtenerEventos (KeyState evento) {
        boolean estado=evento.getState ();
    
        if (estadoTeclas.getKeyCode ()==param.adelante)
            adelante=estado;
        if (estadoTeclas.getKeyCode ()==param.atras)
            atras=estado;
        if (estadoTeclas.getKeyCode ()==param.giroIzq)
            giroIzq=estado;
        if (estadoTeclas.getKeyCode ()==param.giroDer)
            giroDer=estado;
        if (estadoTeclas.getKeyCode ()==param.giroArr)
            giroArr=estado;
        if (estadoTeclas.getKeyCode ()==param.giroAba)
            giroAba=estado;
        if (estadoTeclas.getKeyCode ()==param.strafe)
            adelante=estado;
        if (estadoTeclas.getKeyCode ()==param.chat)
            chat=estado;
        if (estadoTeclas.getKeyCode ()==param.disparoBala)
            disparoBala=estado;
        if (estadoTeclas.getKeyCode ()==param.disparoMisil)
            disparoMisil=estado;
        
        
        if (estadoTeclas.getKeyCode ()==KeyEvent.VK_UP)
            arriba=estado;
        if (estadoTeclas.getKeyCode ()==KeyEvent.VK_DOWN)
            abajo=estado;
        if (estadoTeclas.getKeyCode ()==KeyEvent.VK_LEFT)
            izquierda=estado;
        if (estadoTeclas.getKeyCode ()==KeyEvent.VK_RIGHT)
            derecha=estado;
        if (estadoTeclas.getKeyCode ()==KeyEvent.VK_ENTER)
            enter=estado;                
        if (estadoTeclas.getKeyCode ()==KeyEvent.VK_ESCAPE) {
            escape=estado;
            System.out.println ("escape");
        }     
    }

    
    private int calcularNumeroEventos () {
        int numeroEventos=0;
        
        if (chat) return -1;
        
        if (adelante) numeroEventos++;
        
        if (atras) numeroEventos++;
        
        if (giroIzq) numeroEventos++;
        
        if (giroDer) numeroEventos++;
        
        if (giroArr) numeroEventos++;
        
        if (giroAba) numeroEventos++;
        
        if (disparoBala) numeroEventos++;

        if (disparoMisil) numeroEventos++;

        if (strafeIzq) numeroEventos++;
        
        if (strafeDer) numeroEventos++;
        
        if (strafeArr) numeroEventos++;
        
        if (strafeAba) numeroEventos++;
        
        if (escape) numeroEventos++;
        
        return numeroEventos;
    }
    
    private int [] crearArregloEventos (int cantidad) {
        int eventosTemp []=new int [cantidad];
        int a=0;
            if (adelante) {
                eventosTemp [a]=1;
                a++;
            }
            if (atras) {
                eventosTemp [a]=2;
                a++;
            }
            if (giroIzq) {
                eventosTemp [a]=3;
                a++;
            }
            if (giroDer) {
                eventosTemp [a]=4;
                a++;
            }
            if (giroArr) {
                eventosTemp [a]=5;
                a++;
            }
            if (giroAba) {
                eventosTemp [a]=6;
                a++;
            }
            if (disparoBala) {
                eventosTemp [a]=7;
                a++;
            }
            if (disparoMisil) {
                eventosTemp [a]=8;
                a++;
            }
            if (strafeIzq) {
                eventosTemp [a]=9;
                a++;
            }
            if (strafeDer) {
                eventosTemp [a]=10;
                a++;
            }
            if (strafeArr) {
                eventosTemp [a]=11;
                a++;
            }
            if (strafeAba) {
                eventosTemp [a]=12;
                a++;
            }
            if (escape) {
                eventosTemp [a]=13;
                a++;
            }
        
        return eventosTemp;
    }
    
    public void manejarRespuesta (int idRespuesta) {
		if (idRespuesta==1) {//es la normal dentro del juego
			IteracionJuego ();
        }

        if (idRespuesta==2) {//cuando hay un nuevo jugador
        	IteracionInicial ();
        }

        if (idRespuesta==3) {//cuando ya se va a terminar el juego o alguien va a salir
        	IteracionFinal ();
        }
	}
	
	public void IteracionJuego () {
		nodoPropio=jugadores.buscar (id);

		actualCam.setBack(nodoPropio.getDireccion().rot.invert3x3());
		actualCam.setPosition (nodoPropio.getPosicion());

        mensajeEntrada=jugadores.mensaje;
        //System.out.println ("El mensaje entrante es: "+jugadores.mensaje);
        render.addToChat (jugadores.mensaje);
	}
	
	public void IteracionInicial () {//representa una iteracion del juego en donde hay algun cambio en los jugadores
		System.out.println ("\n--------Aadiendo un nuevo jugador!");
       
        //Ajustando la camara propia
        nodoPropio=jugadores.buscar (id);
        
        actualCam.setBack(nodoPropio.getDireccion().rot.invert3x3());
        actualCam.setPosition (nodoPropio.getPosicion());

        mensajeEntrada=jugadores.mensaje;

        //Recibiendo la nave del nuevo jugador
        conexion.recibir ();
        R=conexion.getRespuesta ();
        
        checkNuevo=true;
        
        datoNuevo=R.dato;
        
	}
	
	public void IteracionFinal () {
		System.out.println ("\n--------Dentro de la iteracion final");
		conexion.recibir ();
        Respuesta Rtemp=conexion.getRespuesta ();
        datoSalida=Rtemp.dato;
        int idSalida=((Integer)datoSalida).intValue();
        if (idSalida==this.idNave) {
        	//sacando a la nave propia
        	//Juego=null;
        } else {
        	Juego.removeObject(Juego.getObjectByName("Nave"+idSalida));
        }
	}
	
	public void run () {
		while (!salir) {
			try {
				long time=getTimeToSleepOnRender ();
            	if (time<0) {
            		//System.out.println ("\nSISTEMA LAG CON: "+time+" milisegundos, asignando render sleep de 5 milisegundos");
            		sleep (5);
            	}
            	else {
            		//System.out.println ("\nasignando render sleep de "+time+" milisegundos");
            		sleep (time);
            	}
				ejecutarComandos ();
			} catch (Exception E) {
				System.out.println ("Error al ejecutarComandos en Manejador Eventos");
				E.printStackTrace();
			}
			
		}
		
	}
	
	public void detener () {
		System.out.println ("\n\n-----------Deteniendo el manejador de eventos");
		balas.salir();
		salir=true;
	}
	
	 /**
     * Devuelve la cantidad de milisegundos para esperar entre cada iteracion de renderizado
     * 
     * @return La diferencia de tiempo entre la espera deseada y el transcurrido: deseado=transcurrido+pendiente
     */
    public long getTimeToSleepOnRender () {
    	if (tiempo==0) {
    		tiempo=new Date ().getTime();
    		return (Parametros.sleepThread);
    	}
    	else {
    		long tiempoMax=Parametros.sleepThread;
    		long tiempo2=new Date ().getTime();//obtengo los miliseg actuales
    		long res=tiempo2-tiempo;//los resto de los milisegundos de la anterior iteracion y obtengo res=la cant de milisegundos transcurridos
    		tiempo=tiempo2;//asigno los milisegundos actuales
    		return (tiempoMax-res);
    	}
    }
    
    public boolean checkNuevoJugador () {
    	return checkNuevo;
    }
    
    public boolean checkSalidaJugador () {
    	return checkSalida;
    }
    
    public void agregarJugador () {
    	/*
    	Object datoTemp []=(Object [])datoNuevo;
        String nombreNaveNueva=(String)datoTemp [1];
        Object3D nueva=(Object3D)datoTemp [0];
        
        try {
        	Juego.removeObject (Juego.getObjectByName(nombreNaveNueva));	
        } catch (Exception E) {
        	
        }
    	    	
        nueva.setName(nombreNaveNueva);*/
    	Object3D nueva=(Object3D)datoNuevo;
        if (nueva!=null) {
        	nueva.setCollisionMode(Object3D.COLLISION_CHECK_OTHERS | Object3D.COLLISION_CHECK_SELF);
        	System.out.println ("\n--------El nombre de la nave nueva es: "+nueva.getName ());
        	Juego.addObject (nueva);
            nueva.build ();
            
            //falta: aadir el color extra a las partes de la nueva nave
            System.out.println ("\n\n-------Se ha agregado y construido: "+nueva.getName ()+" en el juego");
            
            if (nueva.getName ().compareTo (naveNombre)==0) {
            	System.out.println("Eliminando del World Juego a la nave: "+nueva.getName ());
            	Juego.removeObject (nueva);
            }
        }
        else {
        	System.out.println ("\n--------La nave nueva es nula");
        }
        checkNuevo=false;
    }
    
    public void removerJugador () {
    	
    	int idEliminar=((Integer) datoSalida).intValue();
        String naveEliminar="Nave"+idEliminar;
        
        checkSalida=true;

        if (naveEliminar.compareTo (naveNombre)==0) {
        	detener ();
            salida=true;
        } else {
        	System.out.println ("\nSacando "+naveEliminar+" del World");
        	Juego.removeObject(Actual.getObjectByName(naveEliminar));
        }
        
        checkSalida=false;
    }
    
    public void setMensajeChat (String mensaje) {
    	mensajeSalida=mensaje;
    }
    
    public String getMensajeChat () {
    	return mensajeSalida;
    }
    
    public void setRenderThread (RenderThread arender) {
    	render=arender;
    	render.setMensajeChat("");
    }
    
    public void setBulletThread (BulletThread aBalas) {
    	balas=aBalas;
    }
    
    public void appendChatChar () {
    	
    	//System.out.println ("Haciendo el appendChatChar: "+mensajeChat);
    	
        boolean estado=false;
        
    	do {
            estadoTeclas=mapaTeclas.poll();
            if (estadoTeclas!=KeyState.NONE) {
            	estado=estadoTeclas.getState ();
            	if (estadoTeclas.getKeyCode()==KeyEvent.VK_ENTER) {
            		//System.out.println ("enviando el mensaje");
            		mensajeSalida=mensajeChat;
            		chateando=!chateando;
            		render.setEnChat(false);
            	} else if (estadoTeclas.getKeyCode()==KeyEvent.VK_ESCAPE) {
            		//System.out.println ("dejando de chatear");
            		mensajeChat="";
            		chateando=!chateando;
            		render.setEnChat(false);
            		
            	} else if (estadoTeclas.getKeyCode()==KeyEvent.VK_BACK_SPACE || estadoTeclas.getKeyCode()==KeyEvent.VK_DELETE) {
            		System.out.println ("BORRANDO UN CARACTER DEL CHAT");
            		if (mensajeChat.length()>=1)mensajeChat=mensajeChat.substring(0, mensajeChat.length()-1);
            		render.setMensajeChat(mensajeChat);
            	} else {
            		char C=estadoTeclas.getChar();
            		int h=C;
           			if (h!=0)mensajeChat=mensajeChat+C;
           			render.setMensajeChat(mensajeChat);
            		
            	}
                
            }
        } while (estadoTeclas!=KeyState.NONE);
    	
    }

}
