/*
 * Atencion.java
 *
 * Created on 11 de marzo de 2006, 18:33
 */

package Flier_Match.FMServidor;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.Serializable;
import java.net.Socket;
import java.util.ArrayList;
import java.util.Date;

import Flier_Match.FMRed.Direccion;
import Flier_Match.FMRed.ListaRed;
import Flier_Match.FMRed.NodoRed;
import Flier_Match.FMRed.PetNave;
import Flier_Match.FMRed.Peticion;
import Flier_Match.FMRed.Respuesta;

import com.threed.jpct.CollisionEvent;
import com.threed.jpct.CollisionListener;
import com.threed.jpct.Object3D;
import com.threed.jpct.SimpleVector;
import com.threed.jpct.World;
/**
 *
 * @author  Administrador
 * @version 
 */
public class Atencion extends Thread {// TODO verificar bien las conexiones para cuando sale del juego o hay algun error
    boolean salida;
    private ObjectInputStream entradaOb;
    private ObjectOutputStream salidaOb;
    Socket cliente;

    Object3D navePersonal;
    private float Xrot;
    private float Yrot;
    
    String nick;
    int id;
    int vida;

    private Peticion P;
    private Respuesta R;

    String naveNombre="";
    NodoRed nodoPropio=null;

    int errores;

    private ListaRed jugadores;
    
    private int idCambio;//1=nuevo jugador, 2=salida de jugador

    Direccion D;
    
    private World JuegoRef;
    private MovingThread movimientos;
    
    private PublicadorCambios cambios;
    
    private ArrayList cambiosLista;
    private Object obCambio;
    
    private boolean subiendo;
    private int contadorAceleracion;//cuenta el numero de iteraciones para determinar si es tiempo de subir o bajar la velocidad
    private float velocidadTemp=0;
    
    private ColisionesListener CL;
    /** Creates new Atencion */
    public Atencion(Socket ac, ListaRed aj, World juego, MovingThread MT, PublicadorCambios acambios) {
        super ();
        
        JuegoRef=juego;
        //movimientos=MT;
        movimientos=new MovingThread (JuegoRef);
        
        cambios=acambios;
        cambiosLista=new ArrayList ();

        D=new Direccion ();
        
        //0 = inicio del juego, 1 = iteracion normal del juego, 2 = insercion de una nueva nave, 3 eliminacion de alguna nave
        setCambio(0, null);
        
        jugadores=aj;
        errores=0;
        cliente=ac;
        log ("Atendiendo a un cliente");
        salida=false;
        vida=1000;
        try {
        	cliente.setTcpNoDelay(true);
            salidaOb=new ObjectOutputStream (cliente.getOutputStream ());
            entradaOb=new ObjectInputStream (cliente.getInputStream ());
        } catch (Exception E) {
            log ("Error creando los flujos para las conexiones");
            E.printStackTrace();
        }

        Xrot=0;
        Yrot=0;
    }

    public void run () {
        log ("id de jugador: "+jugadores.id);
        manejarPeticiones ();
        evento0();
        manejarRespuestas ();//devuelve la primera respuesta al cliente que es el id de su nave.
        
        long ultimoTiempo1=0;
        long ultimoTiempo2=0;
        
        while (!salida) {
        	ultimoTiempo1=new Date ().getTime();	
        	manejarPeticiones ();
        	
        	limpiarDireccion ();
            if (P.eventos!=null){
            	float Rots[]=movimientos.manejarEventos (P.eventos, navePersonal, Xrot, Yrot);
            	Xrot=Rots [0];
            	Yrot=Rots [1];
            }
            manejarColisiones ();
            manejarRespuestas ();

            //falta: buscar y manejar recepcion de disparos
        	ultimoTiempo2=new Date ().getTime ();
            try {
            	long delta=(ultimoTiempo2-ultimoTiempo1);
            	if (delta<=ServerThread.esperaThreadAtencion) sleep ((ServerThread.esperaThreadAtencion-delta));
            	else {
            		log ("LAG: "+delta+"ms");
            		sleep (5);
            	}
            } catch (Exception E) {
                log ("ERROR: Ha existido un error asignando un tiempo de espera a la Atencion");
                E.printStackTrace();
            }
        }
    }
    
    public void limpiarDireccion () {
        D=null;
        D=new Direccion ();
    }
    
    /**
     * Maneja las colisiones que sufre la nave debido a otras fuentes
     *
     */
    public void manejarColisiones () {
    	if (CL!=null) {
    		Object3D fuenteCol=CL.getSource();
    		if (fuenteCol!=null) {
        		
        		if (fuenteCol==JuegoRef.getObjectByName("Mapa")) { //si el mapa choca contra la nave
        			vida--;
        		} else if (fuenteCol.getName().startsWith("B1_")) {//si la nave fue impactada por una bala tipo 1
        			vida=vida-ServerThread.daoBala1;
        			JuegoRef.removeObject(fuenteCol);
        			//FALTA: ANIMAION DE EXPLOSION DE BALA
        		} else if (fuenteCol.getName().startsWith("M1_")) {//si la nave fue impactada por un misil tipo 1
        			vida=vida-ServerThread.daoMisil1;
        			JuegoRef.removeObject(fuenteCol);
//        			FALTA: ANIMAION DE EXPLOSION DEL MISIL
        		} else if (fuenteCol.getName().startsWith("Nave")) {//Si la nave provoco el choque o fue chocada por otra nave
        			if (fuenteCol==navePersonal) {
        				vida--;
        			}else {
        				vida--;
        				System.out.println ("\n\n\n\n Fuente de la colision es una nave");
        			}
        		}
        	}
    	}
    }

    public void manejarRespuestas () {
        if (P.mensaje.compareTo ("")!=0) {
        	System.out.println ("Mensaje desde el cliente: "+P.mensaje);
        	//jugadores.mensaje=naveNombre+":"+P.mensaje;
        	cambios.setCambio(5, (nick+":"+P.mensaje));
        }

        D.rot=D.rot=navePersonal.getRotationMatrix();
        nodoPropio.setPosicion (navePersonal.getTranslation ());
        nodoPropio.setDireccion (D);
        nodoPropio.setVida (vida);
        nodoPropio.Yrot=Yrot;

        if (Xrot>360) {
        	Xrot=Xrot-360;
        }
        if (Xrot<-360) {
        	Xrot=Xrot+360;
        }
        
        nodoPropio.Xrot=Xrot;

        //log ("IDATENCION de la nueva iteracion es: "+idAtencion);
        
        Object dato []=null;
        if (cambiosLista.size()>0) {
        	dato=(Object [])cambiosLista.get(0);
            cambiosLista.remove(0);
            idCambio=((Integer)dato [0]).intValue();
            obCambio=dato [1];
        } else {
        	idCambio=1;
        	obCambio=null;
        }
        
        
        
        if (idCambio==1) {
            R=new Respuesta (jugadores, 1);
            enviar (R);
        }

        if (idCambio==0) {//Inicio de una atencion, envia el World y empieza las iteraciones normales
            log ("Manejando una respuesta con idAtencion=0");
            R=new Respuesta (JuegoRef, 0);

            enviar (R);

            R=new Respuesta (new Integer(id), 0);
            enviar (R);
            idCambio=1;
        }
        
        if (idCambio==5) {
        	log ("Enviando mensaje de Chat");
        	jugadores.mensaje=(String)obCambio;
        	R=new Respuesta (jugadores, 1);
            enviar (R);
            jugadores.mensaje="";
        }

        if (idCambio==2) {
            log ("Manejando una respuesta con idAtencion=2");
            R=new Respuesta (jugadores, 2);

            enviar (R);

            log ("Se va a enviar la nave del nuevo jugador al cliente");
            //Object3D Nueva=new Object3D (((Object3D)obCambio));

            Object3D Nueva=(Object3D)obCambio;
            if (Nueva==null) {
            	log ("\n--La nave que se va a enviar es nula");
            	enviar (new Respuesta (null, 2));
            }
            else {
            	//Object dato2 []=new Object []{Nueva, (((Object3D)obCambio).getName())};
            	//R=new Respuesta (dato2, 2);
            	R=new Respuesta (Nueva, 2);
                enviar (R);
                log ("Se ha enviado la nave Nueva: "+Nueva.getName());
                if (Nueva.getName().compareTo(naveNombre)==0) {
                	System.out.println ("Agregando el CollisionListener");
                	CL=new ColisionesListener (naveNombre);
                	Nueva.addCollisionListener(CL);
                }
            }
        }

        if (idCambio==3) {
        	
        	log ("\nAlguien va a salir");
        	int idTemp=((Integer)obCambio).intValue();
        	
        	log ("\nQuitando la nave del escencario");
        	
        	R=new Respuesta (jugadores, 3);
            enviar (R);
            
            R=new Respuesta (obCambio, 3);
            enviar (R);
            
            //salir ();
        }

        if (errores>5) salir ();
    }

    public void manejarPeticiones () {
        try {
            P= (Peticion) entradaOb.readObject ();
            
        } catch (Exception E) {
            log ("Error: "+E.getMessage()+" leyendo la peticion desde el cliente: "+id);
            //E.printStackTrace ();
            errores++;
        }
    }
    

    public void salir () {
        //falta mandar a eliminar la nave que se va de todas las maquinas actuales
        log ("Eliminando el nombre del jugador de la lista");
        
        jugadores.eliminar (id);
        JuegoRef.removeObject(JuegoRef.getObjectByName(naveNombre));
        
        cambios.setCambio(3, new Integer (id));
        
        log ("Parando la atencion al cliente: "+id);
        
        salida=true;

        try {
            salidaOb.close ();
            this.stop ();
        } catch (Exception E) {
            log ("Error: "+E.getMessage()+" No se ha podido terminar el thread de la atencion");
            //E.printStackTrace();
        }
    }


    
    private void evento0 () {
        log ("Evento 0");
        PetNave temp=null;
            try {
                temp= (PetNave) entradaOb.readObject ();
            } catch (Exception E) {
                log ("Error obteniendo los datos personalizados del usuario");
                E.printStackTrace();
            }

            //navePersonal=new Object3D (temp.nave);
            
            navePersonal=temp.nave;
            temp.nave=null;
            
            if (navePersonal==null) {
            	log ("\nLa nave obtenida en el petNave es null");
            } else {
            	nick=temp.nick;
                //falta: asignar bien la direccion y posicion iniciales de la nave
                nodoPropio=jugadores.insertar (nick, vida, navePersonal.getTranslation (), null);
                cambios.setCambio(2, navePersonal);
                
                id=nodoPropio.getId ();
                naveNombre="Nave"+id;
                
                navePersonal.setName (naveNombre);
                JuegoRef.addObject (navePersonal);
                ServerThread.tempColor=temp.color;
                
                log ("empezando a construir la nave llamada: "+naveNombre);
                navePersonal.build ();
            	
                log ("Se ha insertado "+nick+" al juego con la nave: "+naveNombre);
 
            }
    }
    
    public void enviar (Object dato) {
        try {
            salidaOb.writeObject (dato);
            salidaOb.reset();
        } catch (Exception E) {
            log ("Error: "+E.getMessage()+" enviando la informacion al usuario: "+id);
            //E.printStackTrace ();
            errores++;
        }
    }
    
    /**
     * Devuelve la diferencia entre el tiempo actual y el tiempo pasado por parametro
     * @param ultimoTiempo es el valor de milisegundos con el cual comparar
     * @return la diferencia de tiempo entre el tiempo actual y el ingresado por parametro
     */
    public long getDeltaTiempo (long ultimoTiempo) {
    	long tiempoActual=new Date ().getTime();
    	return (tiempoActual-ultimoTiempo);
    }
    
    /**
     * Agrega un nuevo registro a la pila de cambios de esta atencion
     * 
     * @param id Es el identificador del tipo de cambio: 1:iteracion normal, 2: nuevo jugador, 3: salida d eun jugador, 4: mensaje de chat
     * @param ob Es un objeto necesario para la ejecucion de este cambio
     */
    public void setCambio (int id, Object ob) {
		Object dato[]=new Object []{new Integer (id), ob};
		cambiosLista.add(dato);
	}

    public void log (String mensaje) {
    	System.out.println ("CLIENTE "+id+" : "+mensaje);
    }
    
    
    
}

